/*
© FER, HPC Architecture and Application Research Center, All rights reserved

Use under License Agreement ONLY.

IF, PRIOR TO DOWNLOADING, STORING, INSTALLING, ACTIVATING OR USING THE WORK, 
(A) YOU DECIDE YOU ARE UNWILLING TO AGREE TO THE TERMS OF THE PROVIDED LICENSE AGREEMENT, or 
(B) YOU DID NOT RECEIVE OR OBTAIN THE LICENSE AGREEMENT, YOU HAVE NO RIGHT TO USE THE WORK AND YOU SHOULD PROMPTLY RETURN THE WORK TO FER, DELETE IT, OR DISABLE IT.
*/

#include "SyntaxMap.h"

SyntaxMap::SyntaxMap()
{
}

map<syntaxElemEnum, SyntaxElementInfo> SyntaxMap::InitializeSyntaxMap()
{
	map<syntaxElemEnum, SyntaxElementInfo> syntaxMap;

	syntaxMap[emulation_prevention_three_byte] = SyntaxElementInfo(FixedLength, 255);
	syntaxMap[forbidden_zero_bit] = SyntaxElementInfo();
	syntaxMap[nal_unit_type] = SyntaxElementInfo(FixedLength, 63);
	syntaxMap[nuh_layer_id] = SyntaxElementInfo(FixedLength, 63);
	syntaxMap[nuh_temporal_id_plus1] = SyntaxElementInfo(FixedLength, 7);
	syntaxMap[vps_video_parameter_set_id] = SyntaxElementInfo(FixedLength, 15);
	syntaxMap[vps_base_layer_internal_flag] = SyntaxElementInfo();
	syntaxMap[vps_base_layer_available_flag] = SyntaxElementInfo();
	syntaxMap[vps_max_layers_minus1] = SyntaxElementInfo(FixedLength, 63);
	syntaxMap[vps_max_sub_layers_minus1] = SyntaxElementInfo(FixedLength, 7);
	syntaxMap[vps_temporal_id_nesting_flag] = SyntaxElementInfo();
	syntaxMap[vps_reserved_0xffff_16bits] = SyntaxElementInfo(FixedLength, (1 << 16) - 1);
	syntaxMap[vps_sub_layer_ordering_info_present_flag] = SyntaxElementInfo();
	syntaxMap[vps_max_dec_pic_buffering_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[vps_max_num_reorder_pics] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[vps_max_latency_increase_plus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[vps_max_layer_id] = SyntaxElementInfo(FixedLength, 63);
	syntaxMap[vps_num_layer_sets_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[layer_id_included_flag] = SyntaxElementInfo();
	syntaxMap[vps_timing_info_present_flag] = SyntaxElementInfo();
	syntaxMap[vps_num_units_in_tick] = SyntaxElementInfo(FixedLength, 4294967295);
	syntaxMap[vps_time_scale] = SyntaxElementInfo(FixedLength, 4294967295);
	syntaxMap[vps_poc_proportional_to_timing_flag] = SyntaxElementInfo();
	syntaxMap[vps_num_ticks_poc_diff_one_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[vps_num_hrd_parameters] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[hrd_layer_set_idx] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[cprms_present_flag] = SyntaxElementInfo();
	syntaxMap[vps_extension_flag] = SyntaxElementInfo();
	syntaxMap[vps_extension_data_flag] = SyntaxElementInfo();
	syntaxMap[sps_video_parameter_set_id] = SyntaxElementInfo(FixedLength, 15);
	syntaxMap[sps_max_sub_layers_minus1] = SyntaxElementInfo(FixedLength, 7);
	syntaxMap[sps_temporal_id_nesting_flag] = SyntaxElementInfo();
	syntaxMap[sps_seq_parameter_set_id] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[chroma_format_idc] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[separate_colour_plane_flag] = SyntaxElementInfo();
	syntaxMap[pic_width_in_luma_samples] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[pic_height_in_luma_samples] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[conformance_window_flag] = SyntaxElementInfo();
	syntaxMap[conf_win_left_offset] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[conf_win_right_offset] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[conf_win_top_offset] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[conf_win_bottom_offset] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[bit_depth_luma_minus8] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[bit_depth_chroma_minus8] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[log2_max_pic_order_cnt_lsb_minus4] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[sps_sub_layer_ordering_info_present_flag] = SyntaxElementInfo();
	syntaxMap[sps_max_dec_pic_buffering_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[sps_max_num_reorder_pics] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[sps_max_latency_increase_plus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[log2_min_luma_coding_block_size_minus3] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[log2_diff_max_min_luma_coding_block_size] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[log2_min_luma_transform_block_size_minus2] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[log2_diff_max_min_luma_transform_block_size] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[max_transform_hierarchy_depth_inter] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[max_transform_hierarchy_depth_intra] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[scaling_list_enabled_flag] = SyntaxElementInfo();
	syntaxMap[sps_scaling_list_data_present_flag] = SyntaxElementInfo();
	syntaxMap[amp_enabled_flag] = SyntaxElementInfo(FixedLength, RefreshContext, 1);
	syntaxMap[sample_adaptive_offset_enabled_flag] = SyntaxElementInfo();
	syntaxMap[pcm_enabled_flag] = SyntaxElementInfo();
	syntaxMap[pcm_sample_bit_depth_luma_minus1] = SyntaxElementInfo(FixedLength, RefreshContext, 15);
	syntaxMap[pcm_sample_bit_depth_chroma_minus1] = SyntaxElementInfo(FixedLength, RefreshContext, 15);
	syntaxMap[log2_min_pcm_luma_coding_block_size_minus3] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[log2_diff_max_min_pcm_luma_coding_block_size] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[pcm_loop_filter_disabled_flag] = SyntaxElementInfo();
	syntaxMap[num_short_term_ref_pic_sets] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[long_term_ref_pics_present_flag] = SyntaxElementInfo();
	syntaxMap[num_long_term_ref_pics_sps] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[lt_ref_pic_poc_lsb_sps] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[used_by_curr_pic_lt_sps_flag] = SyntaxElementInfo();
	syntaxMap[sps_temporal_mvp_enabled_flag] = SyntaxElementInfo();
	syntaxMap[strong_intra_smoothing_enabled_flag] = SyntaxElementInfo();
	syntaxMap[vui_parameters_present_flag] = SyntaxElementInfo();
	syntaxMap[sps_extension_present_flag] = SyntaxElementInfo();
	syntaxMap[sps_range_extension_flag] = SyntaxElementInfo();
	syntaxMap[sps_multilayer_extension_flag] = SyntaxElementInfo();
	syntaxMap[sps_3d_extension_flag] = SyntaxElementInfo();
	syntaxMap[sps_extension_5bits] = SyntaxElementInfo(FixedLength, 31);
	syntaxMap[sps_extension_data_flag] = SyntaxElementInfo();
	syntaxMap[transform_skip_rotation_enabled_flag] = SyntaxElementInfo();
	syntaxMap[transform_skip_context_enabled_flag] = SyntaxElementInfo();
	syntaxMap[implicit_rdpcm_enabled_flag] = SyntaxElementInfo();
	syntaxMap[explicit_rdpcm_enabled_flag] = SyntaxElementInfo();
	syntaxMap[extended_precision_processing_flag] = SyntaxElementInfo(FixedLength, RefreshContext, 1);
	syntaxMap[intra_smoothing_disabled_flag] = SyntaxElementInfo();
	syntaxMap[high_precision_offsets_enabled_flag] = SyntaxElementInfo();
	syntaxMap[persistent_rice_adaptation_enabled_flag] = SyntaxElementInfo(FixedLength, RefreshContext, 1);
	syntaxMap[cabac_bypass_alignment_enabled_flag] = SyntaxElementInfo();
	syntaxMap[pps_pic_parameter_set_id] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[pps_seq_parameter_set_id] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[dependent_slice_segments_enabled_flag] = SyntaxElementInfo();
	syntaxMap[output_flag_present_flag] = SyntaxElementInfo();
	syntaxMap[num_extra_slice_header_bits] = SyntaxElementInfo(FixedLength, 7);
	syntaxMap[sign_data_hiding_enabled_flag] = SyntaxElementInfo();
	syntaxMap[cabac_init_present_flag] = SyntaxElementInfo();
	syntaxMap[num_ref_idx_l0_default_active_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[num_ref_idx_l1_default_active_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[init_qp_minus26] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[constrained_intra_pred_flag] = SyntaxElementInfo();
	syntaxMap[transform_skip_enabled_flag] = SyntaxElementInfo();
	syntaxMap[cu_qp_delta_enabled_flag] = SyntaxElementInfo();
	syntaxMap[diff_cu_qp_delta_depth] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[pps_cb_qp_offset] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[pps_cr_qp_offset] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[pps_slice_chroma_qp_offsets_present_flag] = SyntaxElementInfo();
	syntaxMap[weighted_pred_flag] = SyntaxElementInfo();
	syntaxMap[weighted_bipred_flag] = SyntaxElementInfo();
	syntaxMap[transquant_bypass_enabled_flag] = SyntaxElementInfo();
	syntaxMap[tiles_enabled_flag] = SyntaxElementInfo();
	syntaxMap[entropy_coding_sync_enabled_flag] = SyntaxElementInfo();
	syntaxMap[num_tile_columns_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[num_tile_rows_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[uniform_spacing_flag] = SyntaxElementInfo();
	syntaxMap[column_width_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[row_height_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[loop_filter_across_tiles_enabled_flag] = SyntaxElementInfo();
	syntaxMap[pps_loop_filter_across_slices_enabled_flag] = SyntaxElementInfo();
	syntaxMap[deblocking_filter_control_present_flag] = SyntaxElementInfo();
	syntaxMap[deblocking_filter_override_enabled_flag] = SyntaxElementInfo();
	syntaxMap[pps_deblocking_filter_disabled_flag] = SyntaxElementInfo();
	syntaxMap[pps_beta_offset_div2] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[pps_tc_offset_div2] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[pps_scaling_list_data_present_flag] = SyntaxElementInfo();
	syntaxMap[lists_modification_present_flag] = SyntaxElementInfo();
	syntaxMap[log2_parallel_merge_level_minus2] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[slice_segment_header_extension_present_flag] = SyntaxElementInfo();
	syntaxMap[pps_extension_present_flag] = SyntaxElementInfo();
	syntaxMap[pps_range_extension_flag] = SyntaxElementInfo();
	syntaxMap[pps_multilayer_extension_flag] = SyntaxElementInfo();
	syntaxMap[pps_3d_extension_flag] = SyntaxElementInfo();
	syntaxMap[pps_extension_5bits] = SyntaxElementInfo(FixedLength, 31);
	syntaxMap[pps_extension_data_flag] = SyntaxElementInfo();
	syntaxMap[log2_max_transform_skip_block_size_minus2] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[cross_component_prediction_enabled_flag] = SyntaxElementInfo();
	syntaxMap[chroma_qp_offset_list_enabled_flag] = SyntaxElementInfo();
	syntaxMap[diff_cu_chroma_qp_offset_depth] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[chroma_qp_offset_list_len_minus1] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[cb_qp_offset_list] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[cr_qp_offset_list] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[log2_sao_offset_scale_luma] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[log2_sao_offset_scale_chroma] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[pic_type] = SyntaxElementInfo(FixedLength, 7);
	syntaxMap[ff_byte] = SyntaxElementInfo(FixedLength, 255);
	syntaxMap[cabac_zero_word] = SyntaxElementInfo(FixedLength, (1 << 16) - 1);
	syntaxMap[rbsp_stop_one_bit] = SyntaxElementInfo();
	syntaxMap[rbsp_alignment_zero_bit] = SyntaxElementInfo();
	syntaxMap[alignment_bit_equal_to_one] = SyntaxElementInfo();
	syntaxMap[alignment_bit_equal_to_zero] = SyntaxElementInfo();
	syntaxMap[general_profile_space] = SyntaxElementInfo(FixedLength, 3);
	syntaxMap[general_tier_flag] = SyntaxElementInfo();
	syntaxMap[general_profile_idc] = SyntaxElementInfo(FixedLength, 31);
	syntaxMap[general_profile_compatibility_flag] = SyntaxElementInfo();
	syntaxMap[general_progressive_source_flag] = SyntaxElementInfo();
	syntaxMap[general_interlaced_source_flag] = SyntaxElementInfo();
	syntaxMap[general_non_packed_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_frame_only_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_max_12bit_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_max_10bit_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_max_8bit_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_max_422chroma_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_max_420chroma_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_max_monochrome_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_intra_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_one_picture_only_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_lower_bit_rate_constraint_flag] = SyntaxElementInfo();
	syntaxMap[general_reserved_zero_34bits] = SyntaxElementInfo(NoBinarization, 34);
	syntaxMap[general_reserved_zero_43bits] = SyntaxElementInfo(NoBinarization, 43);
	syntaxMap[general_inbld_flag] = SyntaxElementInfo();
	syntaxMap[general_reserved_zero_bit] = SyntaxElementInfo();
	syntaxMap[general_level_idc] = SyntaxElementInfo(FixedLength, 255);
	syntaxMap[sub_layer_profile_present_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_level_present_flag] = SyntaxElementInfo();
	syntaxMap[reserved_zero_2bits] = SyntaxElementInfo(FixedLength, 3);
	syntaxMap[sub_layer_profile_space] = SyntaxElementInfo(FixedLength, 3);
	syntaxMap[sub_layer_tier_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_profile_idc] = SyntaxElementInfo(FixedLength, 31);
	syntaxMap[sub_layer_profile_compatibility_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_progressive_source_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_interlaced_source_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_non_packed_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_frame_only_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_max_12bit_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_max_10bit_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_max_8bit_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_max_422chroma_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_max_420chroma_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_max_monochrome_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_intra_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_one_picture_only_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_lower_bit_rate_constraint_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_reserved_zero_34bits] = SyntaxElementInfo(NoBinarization, 34);
	syntaxMap[sub_layer_reserved_zero_43bits] = SyntaxElementInfo(NoBinarization, 43);
	syntaxMap[sub_layer_inbld_flag] = SyntaxElementInfo();
	syntaxMap[sub_layer_reserved_zero_bit] = SyntaxElementInfo();
	syntaxMap[sub_layer_level_idc] = SyntaxElementInfo(FixedLength, 255);
	syntaxMap[scaling_list_pred_mode_flag] = SyntaxElementInfo();
	syntaxMap[scaling_list_pred_matrix_id_delta] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[scaling_list_dc_coef_minus8] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[scaling_list_delta_coef] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[last_payload_type_byte] = SyntaxElementInfo(FixedLength, 255);
	syntaxMap[last_payload_size_byte] = SyntaxElementInfo(FixedLength, 255);
	syntaxMap[first_slice_segment_in_pic_flag] = SyntaxElementInfo();
	syntaxMap[no_output_of_prior_pics_flag] = SyntaxElementInfo();
	syntaxMap[slice_pic_parameter_set_id] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[dependent_slice_segment_flag] = SyntaxElementInfo();
	syntaxMap[slice_segment_address] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[slice_reserved_flag] = SyntaxElementInfo();
	syntaxMap[slice_type] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[pic_output_flag] = SyntaxElementInfo();
	syntaxMap[colour_plane_id] = SyntaxElementInfo(FixedLength, 3);
	syntaxMap[slice_pic_order_cnt_lsb] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[short_term_ref_pic_set_sps_flag] = SyntaxElementInfo();
	syntaxMap[short_term_ref_pic_set_idx] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[num_long_term_sps] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[num_long_term_pics] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[lt_idx_sps] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[poc_lsb_lt] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[used_by_curr_pic_lt_flag] = SyntaxElementInfo();
	syntaxMap[delta_poc_msb_present_flag] = SyntaxElementInfo();
	syntaxMap[delta_poc_msb_cycle_lt] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[slice_temporal_mvp_enabled_flag] = SyntaxElementInfo();
	syntaxMap[slice_sao_luma_flag] = SyntaxElementInfo();
	syntaxMap[slice_sao_chroma_flag] = SyntaxElementInfo();
	syntaxMap[num_ref_idx_active_override_flag] = SyntaxElementInfo();
	syntaxMap[num_ref_idx_l0_active_minus1] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[num_ref_idx_l1_active_minus1] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[mvd_l1_zero_flag] = SyntaxElementInfo();
	syntaxMap[cabac_init_flag] = SyntaxElementInfo();
	syntaxMap[collocated_from_l0_flag] = SyntaxElementInfo();
	syntaxMap[collocated_ref_idx] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[five_minus_max_num_merge_cand] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[slice_qp_delta] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[slice_cb_qp_offset] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[slice_cr_qp_offset] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[cu_chroma_qp_offset_enabled_flag] = SyntaxElementInfo();
	syntaxMap[deblocking_filter_override_flag] = SyntaxElementInfo();
	syntaxMap[slice_deblocking_filter_disabled_flag] = SyntaxElementInfo();
	syntaxMap[slice_beta_offset_div2] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[slice_tc_offset_div2] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[slice_loop_filter_across_slices_enabled_flag] = SyntaxElementInfo();
	syntaxMap[num_entry_point_offsets] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[offset_len_minus1] = SyntaxElementInfo(ExpGolomb, RefreshContext, 0);
	syntaxMap[entry_point_offset_minus1] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[slice_segment_header_extension_length] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[slice_segment_header_extension_data_byte] = SyntaxElementInfo(FixedLength, 255);
	syntaxMap[ref_pic_list_modification_flag_l0] = SyntaxElementInfo();
	syntaxMap[list_entry_l0] = SyntaxElementInfo();
	syntaxMap[ref_pic_list_modification_flag_l1] = SyntaxElementInfo();
	syntaxMap[list_entry_l1] = SyntaxElementInfo();
	syntaxMap[luma_log2_weight_denom] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[delta_chroma_log2_weight_denom] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[luma_weight_l0_flag] = SyntaxElementInfo();
	syntaxMap[chroma_weight_l0_flag] = SyntaxElementInfo();
	syntaxMap[delta_luma_weight_l0] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[luma_offset_l0] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[delta_chroma_weight_l0] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[delta_chroma_offset_l0] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[luma_weight_l1_flag] = SyntaxElementInfo();
	syntaxMap[chroma_weight_l1_flag] = SyntaxElementInfo();
	syntaxMap[delta_luma_weight_l1] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[luma_offset_l1] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[delta_chroma_weight_l1] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[delta_chroma_offset_l1] = SyntaxElementInfo(ExpGolomb, PrecalculateValue, 0);
	syntaxMap[inter_ref_pic_set_prediction_flag] = SyntaxElementInfo();
	syntaxMap[delta_idx_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[delta_rps_sign] = SyntaxElementInfo();
	syntaxMap[abs_delta_rps_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[used_by_curr_pic_flag] = SyntaxElementInfo();
	syntaxMap[use_delta_flag] = SyntaxElementInfo();
	syntaxMap[num_negative_pics] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[num_positive_pics] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[delta_poc_s0_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[used_by_curr_pic_s0_flag] = SyntaxElementInfo();
	syntaxMap[delta_poc_s1_minus1] = SyntaxElementInfo(ExpGolomb, 0);
	syntaxMap[used_by_curr_pic_s1_flag] = SyntaxElementInfo();
	syntaxMap[end_of_slice_segment_flag] = SyntaxElementInfo(FixedLength, 1, 0, 0, 0, 0);
	syntaxMap[end_of_subset_one_bit] = SyntaxElementInfo(FixedLength, 1, 1, 0, 0, 0);
	syntaxMap[sao_merge_left_flag] = SyntaxElementInfo(FixedLength, 1, 2, 0, 1, 0);
	syntaxMap[sao_merge_up_flag] = SyntaxElementInfo(FixedLength, 1, 3, 0, 1, 0);
	syntaxMap[sao_type_idx_luma] = SyntaxElementInfo(TruncatedRice, 0, 2, 4, 0, 1, 1);
	syntaxMap[sao_type_idx_chroma] = SyntaxElementInfo(TruncatedRice, 0, 2, 5, 0, 1, 1);
	syntaxMap[sao_offset_abs] = SyntaxElementInfo(TruncatedRice, 0, -1, PrecalculateParameter, 6, 0, 0, 0);
	syntaxMap[sao_offset_sign] = SyntaxElementInfo(FixedLength, 1, 7, 0, 0, 0);
	syntaxMap[sao_band_position] = SyntaxElementInfo(FixedLength, 31, 8, 0, 0, 0);
	syntaxMap[sao_eo_class_luma] = SyntaxElementInfo(FixedLength, 3, 9, 0, 0, 0);
	syntaxMap[sao_eo_class_chroma] = SyntaxElementInfo(FixedLength, 3, 10, 0, 0, 0);
	syntaxMap[split_cu_flag] = SyntaxElementInfo(FixedLength, 1, 11, 0, 3, 2);
	syntaxMap[cu_transquant_bypass_flag] = SyntaxElementInfo(FixedLength, 1, 12, 0, 1, 3);
	syntaxMap[cu_skip_flag] = SyntaxElementInfo(FixedLength, 1, 13, 0, 0, 4);
	syntaxMap[pred_mode_flag] = SyntaxElementInfo(FixedLength, 1, RefreshContext, 14, 0, 0, 5);
	syntaxMap[part_mode] = SyntaxElementInfo(Special, 16, 0, 1, 6);
	syntaxMap[pcm_flag] = SyntaxElementInfo(FixedLength, 1, 17, 0, 0, 0);
	syntaxMap[pcm_alignment_zero_bit] = SyntaxElementInfo();
	syntaxMap[prev_intra_luma_pred_flag] = SyntaxElementInfo(FixedLength, 1, 18, 0, 1, 7);
	syntaxMap[mpm_idx] = SyntaxElementInfo(TruncatedRice, 0, 2, 19, 0, 0, 0);
	syntaxMap[rem_intra_luma_pred_mode] = SyntaxElementInfo(FixedLength, 31, 20, 0, 0, 0);
	syntaxMap[intra_chroma_pred_mode] = SyntaxElementInfo(Special, 21, 0, 1, 8);
	syntaxMap[rqt_root_cbf] = SyntaxElementInfo(FixedLength, 1, 22, 0, 0, 9);
	syntaxMap[merge_idx] = SyntaxElementInfo(TruncatedRice, 0, -1, PrecalculateParameter, 24, 0, 0, 11);
	syntaxMap[merge_flag] = SyntaxElementInfo(FixedLength, 1, 23, 0, 0, 10);
	syntaxMap[inter_pred_idc] = SyntaxElementInfo(Special, 25, 0, 0, 12);
	syntaxMap[ref_idx_l0] = SyntaxElementInfo(TruncatedRice, 0, -1, PrecalculateParameter, 26, 0, 0, 13);
	syntaxMap[mvp_l0_flag] = SyntaxElementInfo(FixedLength, 1, 28, 0, 0, 14);
	syntaxMap[ref_idx_l1] = SyntaxElementInfo(TruncatedRice, 0, -1, PrecalculateParameter, 27, 0, 0, 13);
	syntaxMap[mvp_l1_flag] = SyntaxElementInfo(FixedLength, 1, 29, 0, 0, 14);
	syntaxMap[pcm_sample_luma] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[pcm_sample_chroma] = SyntaxElementInfo(FixedLength, PrecalculateParameter);
	syntaxMap[split_transform_flag] = SyntaxElementInfo(FixedLength, 1, 30, 0, 3, 15);
	syntaxMap[cbf_cb] = SyntaxElementInfo(FixedLength, 1, 31, 0, 4, 17);
	syntaxMap[cbf_cr] = SyntaxElementInfo(FixedLength, 1, 32, 0, 4, 17);
	syntaxMap[cbf_luma] = SyntaxElementInfo(FixedLength, 1, 33, 0, 2, 16);
	syntaxMap[abs_mvd_greater0_flag] = SyntaxElementInfo(FixedLength, 1, 34, 0, 0, 18);
	syntaxMap[abs_mvd_greater1_flag] = SyntaxElementInfo(FixedLength, 1, 35, 0, 1, 19);
	syntaxMap[abs_mvd_minus2] = SyntaxElementInfo(ExpGolomb, 1, 36, 0, 0, 0);
	syntaxMap[mvd_sign_flag] = SyntaxElementInfo(FixedLength, 1, 37, 0, 0, 0);
	syntaxMap[cu_qp_delta_abs] = SyntaxElementInfo(Special, 38, 0, 2, 20);
	syntaxMap[cu_qp_delta_sign_flag] = SyntaxElementInfo(FixedLength, 1, 39, 0, 0, 0);
	syntaxMap[cu_chroma_qp_offset_flag] = SyntaxElementInfo(FixedLength, 1, 40, 0, 1, 21);
	syntaxMap[cu_chroma_qp_offset_idx] = SyntaxElementInfo(TruncatedRice, 0, -1, PrecalculateParameter, 41, 0, 1, 22);
	syntaxMap[transform_skip_flag] = SyntaxElementInfo(FixedLength, 1, RefreshContext, 44, 0, 1, 25);
	syntaxMap[explicit_rdpcm_flag] = SyntaxElementInfo(FixedLength, 1, 45, 0, 0, 26);
	syntaxMap[explicit_rdpcm_dir_flag] = SyntaxElementInfo(FixedLength, 1, 46, 0, 0, 27);
	syntaxMap[last_sig_coeff_x_prefix] = SyntaxElementInfo(TruncatedRice, 0, -1, PrecalculateParameter, RefreshContext, 47, 0, 18, 28);
	syntaxMap[last_sig_coeff_y_prefix] = SyntaxElementInfo(TruncatedRice, 0, -1, PrecalculateParameter, RefreshContext, 48, 0, 18, 29);
	syntaxMap[last_sig_coeff_x_suffix] = SyntaxElementInfo(FixedLength, -1, PrecalculateParameter, 49, 0, 0, 0);
	syntaxMap[last_sig_coeff_y_suffix] = SyntaxElementInfo(FixedLength, -1, PrecalculateParameter, 50, 0, 0, 0);
	syntaxMap[coded_sub_block_flag] = SyntaxElementInfo(FixedLength, 1, 51, 0, 4, 30);
	syntaxMap[sig_coeff_flag] = SyntaxElementInfo(FixedLength, 1, 52, 0, 42, 31);
	syntaxMap[coeff_abs_level_greater1_flag] = SyntaxElementInfo(FixedLength, 1, 53, 0, 24, 32);
	syntaxMap[coeff_abs_level_greater2_flag] = SyntaxElementInfo(FixedLength, 1, 54, 0, 6, 33);
	syntaxMap[coeff_sign_flag] = SyntaxElementInfo(FixedLength, 1, 56, 0, 0, 0);
	syntaxMap[coeff_abs_level_remaining] = SyntaxElementInfo(Special, RefreshContext, 55, 0, 0, 0);
	syntaxMap[log2_res_scale_abs_plus1] = SyntaxElementInfo(TruncatedRice, 0, 4, 42, 0, 8, 0);
	syntaxMap[res_scale_sign_flag] = SyntaxElementInfo(FixedLength, 1, 43, 0, 2, 0);

	return syntaxMap;
}

SyntaxMap::~SyntaxMap()
{
}
